clear

local N=100
local T=10
local TT=100

local obs=`N'*`T'
set obs `obs'
gen pid=int((_n-1)/`T')+1

sort pid
qui by pid: gen wave=_n

tsset pid wave

local theta=.5

gen results=.

local jj=1
while `jj'<=`TT'{

gen alpha=invnorm(uniform())
sort pid
qui bys pid (wave): replace alpha=alpha[1]
gen epsilon=invnorm(uniform())

sort pid
qui bys pid (wave): gen y=alpha/(1-`theta')+1/sqrt(1-`theta'^2)*epsilon if _n==1
qui bys pid (wave): replace y=`theta'*y[_n-1]+alpha+epsilon if _n>1


xtabond2 y l.y, gmmstyle(y,lag(2 10)) noleveleq
matrix res=e(b)
sort pid wave
replace results=res[1,1] if _n==`jj'

drop alpha
drop epsilon
drop y
local jj=`jj'+1
}

qui su results
scalar a1=r(mean)
scalar a2=sqrt(r(Var))
sort results
scalar a3=results[`TT'/20]
scalar a4=results[`TT'/10]
gen devresults=(results-`theta')^2
su devresults
scalar a5=r(mean)
replace devresults=abs(results-`theta')
su devresults
scalar a6=r(mean)
_pctile results, p(50)
scalar a7=r(r1)

/* Arellano Bond */

/* Mean */
di a1

/* Median */
di a7


/* Standard deviation */
di a2

/* phat, .05 */
di a3

/* phat, .10 */
di a4

/* Mean Squared Error */
di a5

/* Mean Absolute Error */
di a6



















