clear

local N=100
local T=10
local TT=100

local obs=`N'*`T'
set obs `obs'
gen pid=int((_n-1)/`T')+1

sort pid
qui by pid: gen wave=_n

tsset pid wave

local theta1=.5
local theta2=0

gen results1=.
gen results2=.

local jj=1
while `jj'<=`TT'{

gen alpha=invnorm(uniform())
qui bys pid: replace alpha=alpha[1]

gen e1=invnorm(uniform())
qui bys pid: replace e1=e1[1]

gen e2=invnorm(uniform())
qui bys pid: replace e2=e2[1]

gen v1=1.1547005*e1
gen v2=0.57735027*e1+e2
qui bys pid: gen y=alpha/(1-`theta1'-`theta2')+v1 if _n==1
qui bys pid: replace y=alpha/(1-`theta1'-`theta2')+v2 if _n==2

qui bys pid (wave): replace y=`theta1'*y[_n-1]+`theta2'*y[_n-2]+alpha+invnorm(uniform()) if _n>2

xtabond2 y l.y l2.y, gmmstyle(y,lag(2 10)) noconst noleveleq
matrix res=e(b)
replace results1=res[1,1] if _n==`jj'
replace results2=res[1,2] if _n==`jj'


drop alpha
drop e* v*
drop y
local jj=`jj'+1
}

qui su results1
scalar a1=r(mean)
scalar a2=sqrt(r(Var))
sort results1
scalar a3=results1[`TT'/20]
scalar a4=results1[`TT'/10]
gen devresults1=(results1-`theta1')^2
su devresults1
scalar a5=r(mean)
replace devresults1=abs(results1-`theta1')
su devresults1
scalar a6=r(mean)
_pctile results1, p(50)
scalar a7=r(r1)

/* Arellano Bond, theta1 */

/* Mean */
di a1

/* Median */
di a7


/* Standard deviation */
di a2

/* phat, .05 */
di a3

/* phat, .10 */
di a4

/* Mean Squared Error */
di a5

/* Mean Absolute Error */
di a6


qui su results2
scalar a1=r(mean)
scalar a2=sqrt(r(Var))
sort results2
scalar a3=results2[`TT'/20]
scalar a4=results2[`TT'/10]
gen devresults2=(results2-`theta2')^2
su devresults2
scalar a5=r(mean)
replace devresults2=abs(results2-`theta2')
su devresults2
scalar a6=r(mean)
_pctile results2, p(50)
scalar a7=r(r1)

/* Arellano Bond, theta2 */

/* Mean */
di a1

/* Median */
di a7


/* Standard deviation */
di a2

/* phat, .05 */
di a3

/* phat, .10 */
di a4

/* Mean Squared Error */
di a5

/* Mean Absolute Error */
di a6




































