clear

local N=100
local T=100
local TT=100

local obs=`N'*`T'
set obs `obs'
gen pid=int((_n-1)/`T')+1

gen x=invnorm(uniform())
sort pid
qui by pid: egen meanx=mean(x)

local theta=1

gen results=.

local jj=1
while `jj'<=`TT'{

gen alpha=meanx+invnorm(uniform())
sort pid
qui by pid: replace alpha=alpha[1]
gen epsilon=uniform()
replace epsilon=ln(epsilon/(1-epsilon))

gen y=(`theta'*x+alpha+epsilon>0)

qui clogit y x, group(pid)
matrix res=e(b)
replace results=res[1,1] if _n==`jj'

drop alpha
drop epsilon
drop y

local jj=`jj'+1
}

qui su results
scalar a1=r(mean)
scalar a2=sqrt(r(Var))
sort results
scalar a3=results[`TT'/20]
scalar a4=results[`TT'/10]
gen devresults=(results-`theta')^2
su devresults
scalar a5=r(mean)
replace devresults=abs(results-`theta')
su devresults
scalar a6=r(mean)
_pctile results, p(50)
scalar a7=r(r1)

/* Conditional Logit */

/* Mean */
di a1

/* Median */
di a7


/* Standard deviation */
di a2

/* phat, .05 */
di a3

/* phat, .10 */
di a4

/* Mean Squared Error */
di a5

/* Mean Absolute Error */
di a6



















